package com.bluerabbit.librarysystem.view;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;

import com.bluerabbit.librarysystem.beans.ReaderInfoBeans;
import com.bluerabbit.librarysystem.dao.ReaderInfoBeansDAO;
import com.bluerabbit.librarysystem.listener.ReaderInfoUpdateView_ActionListener;
/**
 * Ϣ鿴޸ģ
 * @author minuy
 *
 */
@SuppressWarnings("serial")
public class ReaderInfoUpdateView extends JDialog {
	private boolean mode;//t:add.f:fix
	private JPanel mainView;
	private JPanel contentView;
	private JPanel functionView;
	private int WindowsHeight;
	private int windowsWidth;

	//Ϣ
	private ComboJLAndJT cltReaderID;//ѧ
	private ComboJLAndJT cltReaderName;//
	private ComboJLAndJT cltApart;//ѧԺ
	private ComboJLAndJT cltTheClass;//༶
	private ComboJLAndJT cltTelNo;//༶

	private JPanel pnlSex;
	private JComboBox<String> jcbSex;
	private JLabel LabSex;//Ա


	private JButton ok;
	private JButton cancel;

	private ReaderInfoManageView rv;
	boolean editor;
	private String readerId = null;

	String[] select = {"","Ů"};//Ա
	/**
	 * Ϣϸҳ
	 * @param rv Ϣͼ
	 * @param title ǰҳ
	 * @param readerId ߵѧţѧŸѧżظϢûΪnullĻͲ
	 * @param editor Ƿܱ༭
	 */
	public ReaderInfoUpdateView(ReaderInfoManageView rv,String title,String readerId,boolean editor){
		super(rv,title,true);
		this.rv = rv;
		mode = true;
		this.editor = editor;

		//ѧΪգģʽΪfalse,Ϣ
		if(readerId == null){
			readerId = "";
		}
		if(!readerId.equals("")){
			mode = false;
			this.readerId = readerId;
		}

		//øͼĴС
		WindowsHeight = rv.getHeight();
		windowsWidth = rv.getWidth();

		//沿
		mainView = new JPanel();
		functionView = new JPanel();
		contentView = new JPanel();
		pnlSex = new JPanel();

		/**
		 * ӺͲ鿴ĴС
		 */
		int w;
		if(!editor){
			//鿴ģʽ
			w = 130;
		}else{
			//ģʽ
			w = 20;
		}

		//Ϣ
		cltReaderID = new ComboJLAndJT("ѧ    ţ",editor,w);
		cltReaderName = new ComboJLAndJT("    ",editor,w);
		cltApart = new ComboJLAndJT("ѧ    Ժ",editor,w);
		cltTheClass = new ComboJLAndJT("    ",editor,w);
		cltTelNo = new ComboJLAndJT("ϵʽ",editor,w);
		jcbSex = new JComboBox<String>();
		LabSex = new JLabel("    ");



		ok = new JButton("ȷ");
		cancel = new JButton("ȡ");

		if(!mode){
			//Ϊգ޸ϢʼϢ
			System.out.println("˺Ϣ");
			loader(readerId);
			mode = false;
			ok = new JButton("");
			//ֹѧ
			//cltReaderID.getGettxt().setEditable(false);
		}
		if(!editor){
			//ֹԱ
			jcbSex.setEnabled(false);
		}

		Init();
	}

	/**
	 * ضϢôʱĳʼֵ
	 * @param readerId 򿪵ĶϢ
	 */
	private void loader(String readerId) {
		// TODO Auto-generated method stub
		ReaderInfoBeans readerInfo = null;
		//ȡͼϢ
		readerInfo = new ReaderInfoBeansDAO().getReaderInfoById(readerId);

		//öϢ
		cltReaderID.setIText(readerInfo.getReaderID());//ѧ

		cltReaderName.setIText(readerInfo.getReaderName());//

		cltApart.setIText(readerInfo.getApart());//ѧԺ

		cltTheClass.setIText(readerInfo.getTheClass ());//༶

		cltTelNo.setIText(readerInfo.getTelNo());//ϵʽ

		if(readerInfo.getSex().equals("Ů")){
			select[0] = "Ů";
			select[1] = "";
		}
	}

	/**
	 * ʼڲãòʲô
	 */
	private void Init() {
		this.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
		this.setSize(windowsWidth-550, WindowsHeight-350);
		CenterView.CenterByWindow(this);
		//ûڴС

		//ò
		mainView.setLayout(new BorderLayout());
		contentView.setLayout(new GridLayout(3,2));
		functionView.setLayout(new FlowLayout(FlowLayout.RIGHT));

		//ͼ߿
		contentView.setBorder(BorderFactory.createMatteBorder(0, 0, 1, 0, Color.GRAY));

		//ݲϢ
		contentView.add(cltReaderID);//ѧ
		contentView.add(cltReaderName);//
		contentView.add(cltApart);//ѧԺ

		pnlSex.setLayout(new FlowLayout());

		pnlSex.add(LabSex);
		pnlSex.add(jcbSex);
		contentView.add(pnlSex);//Ա
		jcbSex.setModel(new DefaultComboBoxModel<String>(select));
		jcbSex.setPreferredSize(new Dimension(130,27));


		contentView.add(cltTheClass);//༶
		contentView.add(cltTelNo);//ϵʽ



		//Ӽ¼
		ReaderInfoUpdateView_ActionListener listener = new ReaderInfoUpdateView_ActionListener(this,rv);
		cancel.addActionListener(listener);
		ok.addActionListener(listener);

		//Ա༭
		if(editor){
			functionView.add(ok);
		}
		functionView.add(cancel);


		mainView.add(functionView, BorderLayout.SOUTH);
		mainView.add(contentView, BorderLayout.CENTER);
		this.add(mainView);
		this.setVisible(true);
	}

	/**
	 * ģʽ޸ģʽfalse޸ģʽtrueģʽ
	 * @return ģʽ
	 */
	public boolean isMode() {
		return mode;
	}

	/**
	 * ṩĿؼӿں
	 * @return ȷ°ť
	 */
	public JButton getOk() {
		return this.ok;
	}

	/**
	 * ṩĿؼӿں
	 * @return ȡť
	 */
	public JButton getCancel() {
		return this.cancel;
	}

	/**
	 * ṩĿؼӿں
	 * @return ѧ
	 */
	public ComboJLAndJT getCltReaderID() {
		return cltReaderID;
	}	

	/**
	 * ṩĿؼӿں
	 * @return 
	 */
	public ComboJLAndJT getCltReaderName() {
		return cltReaderName;
	}

	/**
	 * ṩĿؼӿں
	 * @return ѧԺ
	 */
	public ComboJLAndJT getCltApart() {
		return cltApart;
	}

	/**
	 * ṩĿؼӿں
	 * @return ߰༶
	 */
	public ComboJLAndJT getCltTheClass() {
		return cltTheClass;
	}

	/**
	 * ṩĿؼӿں
	 * @return ϵʽ
	 */
	public ComboJLAndJT getCltTelNo() {
		return cltTelNo;
	}

	/**
	 * ṩĿؼӿں
	 * @return Ա
	 */
	public JComboBox<String> getJcbSex(){
		return jcbSex;
	}
	/**
	 * ȡID
	 * @return ո½ʱĶIDûеĻnull
	 */
	public String getReaderId() {
		return readerId;
	}
}
